#include <iostream>
#include <string>

using namespace std;

#include "empl40a.h"	// Our Empl class...

// The default constructor doesn't take any arguments
Empl::Empl()
{
    salary = 0.0;
    fname = lname = 0;
    SetFname("none");
    SetLname("none");
}

// This one takes two arguments
Empl::Empl(const char *fn, const char *ln)
{
    salary = 0.0;
    fname = lname = 0;
    SetFname(fn);
    SetLname(ln);
}

Empl::~Empl()
{
    //  Nothing to do here (yet)
}

//  Update the salary only.
void Empl::Update(float sal)
{
    SetSalary(sal);
}

//  Update first and last name.
void Empl::Update(const char *fn, const char *ln)
{
    SetFname(fn);
    SetLname(ln);
}

void Empl::SetFname(const char *fn)
{
    delete [] fname;
    fname = new char[strlen(fn)+1];
    strcpy(fname, fn);
}

void Empl::SetLname(const char *ln)
{
    delete [] lname;
    lname = new char[strlen(ln)+1];
    strcpy(lname, ln);
}

void Empl::Print()
{
    cout << "Name:   " << GetLname() << ", " << GetFname() << endl;
    cout << "Salary: " << GetSalary() << endl;
}
