#ifndef empl_h_
#define empl_h_

//  The employee class
//
//  Includes (most) information about an employee.  The data fields
//  are protected from modification by the application.

class Empl {
    char *fname, *lname;
    float salary;
    void InitEmpl();	// Private 'cuz no derived classes should ever use
  protected:
    void _print();	// Prints all data fields w/o commentary
  public:
    Empl();			// Default constructor
    Empl(const char *fn, const char *ln);
    ~Empl();			// Destructor

    void Print();		// Prints all data fields w/ commentary
    void Update(float sal);
    void Update(const char *fn, const char *ln);

    //	Functions to set the values of the data fields
    //    The strncpy() relies on all fields being zero'd by the
    //    constructor.
    void SetSalary(float sal)	{ salary = sal; }
    void SetFname(const char *fn);
    void SetLname(const char *ln);

    //	Functions to retrieve the data fields' values.
    const float GetSalary()		{ return salary; }
    const char* GetFname()		{ return fname; }
    const char* GetLname()		{ return lname; }
};

#endif // empl_h_
